package com.jqtx.windows.service.impl;

import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.CharsetUtil;
import cn.hutool.extra.ssh.Sftp;
import com.jqtx.infrastructure.oss.starter.config.OssUtils;
import com.jqtx.windows.common.config.SftpConfig;
import com.jqtx.windows.component.enums.SftpTypeEnum;
import com.jqtx.windows.service.SftpService;
import com.jqtx.windows.web.response.JsonResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class SftpServiceImpl implements SftpService {
    @Autowired
    private OssUtils ossUtils;

    @Autowired
    private SftpConfig sftpConfig;

    @Override
    public JsonResult<String> getFileByType(String date, String type) {
        String ossUrl = "ZN/" + type + "/" + type + "_" + date + ".txt";
        String dir = "/download/" + type + "/" + date;
        String sfptName = type + "_" + date + ".txt";
        String path = "/" + type + "_sftp.txt";
        if (!ossUtils.exist(ossUrl)) {
            Sftp sftp = new Sftp(sftpConfig.getSshHost(), sftpConfig.getSshPort(), sftpConfig.getSshUser(), sftpConfig.getSshPass(), CharsetUtil.CHARSET_UTF_8);
            try {
                if (sftp.isDir(dir)) {
                    sftp.cd(dir);
                    sftp.get(sfptName, path);
                    ossUtils.ossUpload(ossUrl, FileUtil.file(path));
                    FileUtil.del(path);
                } else {
                    return JsonResult.error("浙农" + date + "日无" + SftpTypeEnum.getByCode(type).getMsg() + "！");
                }
            } catch (Exception e) {
            } finally {
                //关闭sftp连接
                sftp.close();
            }
        }
        return JsonResult.success(ossUtils.generateTempURL(ossUrl));

    }


}
